﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO;


namespace WindowsFormsGame15
{
    public delegate void Delegate_Void_Int(int par);
    public delegate void Delegate_Void_String(string par);
    public partial class FormGame15 : Form
    {
        Game15 myGame;
        public Delegate_Void_Int delint;
        public Delegate_Void_String delstring;

        string gamer = "computer";
        Button[] cells;
        const int N = 4;    //число ячеек в ряду
        const int HW = 60;  //размер ячейки в пикселях
        const int HW2 = 30;
        const int HW3 = 10;
        Panel myPanel;
        Point ePoint;   //расположение свободной ячейки
        Button button;
        Point point;
        Size size;
        Font font;
        int sleepingTime = 15;

        Thread gamethread;
        public FormGame15()
        {
            InitializeComponent();
            myGame = new Game15(this);
            delint = Moving;
            delstring = ToList;
            InitControls();
        }
        private void InitControls()
        {
            //Создание панели для рисования
            myPanel = new Panel();
            myPanel.Parent = this;
            myPanel.Size = new Size(N * HW, N * HW);
            myPanel.BackColor = SystemColors.GradientActiveCaption;
            myPanel.Location = new Point(HW, HW);

            font = new Font("Elefant", HW3);
            
            cells = new Button[N * N];
            point = new Point(HW, HW);
            size = new Size(HW, HW);

            //Горизонтальные и вертикальные заголовки строк и столбцов
            const string HorNames = "ABCDEFGHIJK";
            const string VerNames = "12345678910";
            Label[] labelsHor = new Label[N];
            Label[] labelsVer = new Label[N];
            for (int i = 0; i < N; i++)
            {
                labelsHor[i] = new Label();
                labelsHor[i].Parent = this;
                labelsHor[i].Text = HorNames[i].ToString();
                labelsHor[i].Font = font;
                labelsHor[i].Location = new Point((i+1) * HW + HW3, HW - HW2);
                labelsHor[i].Size = new Size(HW2, HW2);

                labelsVer[i] = new Label();
                labelsVer[i].Parent = this;
                labelsVer[i].Text = VerNames[i].ToString();
                labelsVer[i].Font = font;
                labelsVer[i].Location = new Point( HW - HW2, (i + 1) * HW + HW3);
                labelsVer[i].Size = new Size(HW2, HW2); 
            }
            //Рисование
            ShowButtons();
        }
        /// <summary>
        /// Отображает кнопки - ячейки на панели
        /// </summary>
        private void ShowButtons()
        {

            if (myPanel.Controls != null) myPanel.Controls.Clear();
            progressBarCount.Value = 0;
            textBoxCurrent.Text = "";
            textBoxResult.Text = "";
            listBoxMoves.Items.Clear();
            //myGame.moves = 0;
            for (int i = 1; i < N * N; i++)
            {
                button = new Button();
                button.BackColor = Color.Coral;
                button.Size = new Size(HW, HW);
                button.Location = FindLocation(i);
                button.Font = font;
                button.Text = i.ToString();
                button.Click += new EventHandler(button_Click);

                cells[i] = button;
                myPanel.Controls.Add(cells[i]);

            }
            ePoint = FindLocation(0);
        }

        /// <summary>
        /// Перемещение ячейки: из i в пустую ячейку
        /// </summary>
        /// <param name="i">источник</param>        
        public void Moving(int i)
        {
            point = cells[i].Location;
            cells[i].Location = ePoint;
            ePoint = point;
            Thread.Sleep(sleepingTime);
        }
        /// <summary>
        /// Поиск расположения ячейки с номером i  в таблице
        /// </summary>
        /// <param name="i">номер на ячейке </param>
        /// <returns>Точку расположения ячейки на панели</returns>
        private Point FindLocation(int i)
        {

            int j = myGame.indexes[i];

            int r = j / N;
            int c = j % N;
            int x = c * HW;
            int y = r * HW;

            return new Point(x, y);
        }
        /// <summary>
        /// Поиск кнопки по ее расположению
        /// </summary>
        /// <param name="loc">положение кнопки</param>
        /// <returns>индекс в массиве cells</returns>
        private int FindCell(Point loc)
        {
            int index = 0;
            for (int i = 1; i < N * N; i++)
                if (cells[i].Location.X == loc.X && cells[i].Location.Y == loc.Y)
                { index = i; break; }
            return index;

        }
        private void buttonStart_Click(object sender, EventArgs e)
        {
            textBoxResult.Text = "start";
            textBoxCurrent.Text = "";
            progressBarCount.Value = 0;
            ListHeader();
            //myGame.StartGame();

            gamethread = new Thread(myGame.StartGame);
            gamethread.Name = "Game_Thread";
            //gamethread.Priority = ThreadPriority.BelowNormal;
            gamethread.Start();
        }
        /// <summary>
        /// Печать расстановки в заголовке списка
        /// </summary>
        private void ListHeader()
        {
            listBoxMoves.Items.Clear();
            string sr = "";
            listBoxMoves.Items.Add("Расстановка: ");
            for (int r = 0; r < N; r++)
            {
                sr = "\t";
                for (int c = 0; c < N; c++)
                    sr += myGame.values[r * N + c].ToString() + "\t";
                listBoxMoves.Items.Add(sr);

            }
            listBoxMoves.Items.Add("");

        }

        private void сохранитьРасстановкуToolStripMenuItem_Click(object sender, EventArgs e)
        {
            StreamWriter configuration;
            string configName = "";
            if (this.saveFileDialog1.ShowDialog() == DialogResult.OK)
                configName = saveFileDialog1.FileName;
            configuration = File.CreateText(configName);
            string config = "";
            for (int i = 0; i < N * N; i++)
            {
             //   if (myGame.values[i] != 0)
              //      config = config + myGame.values[i] + " ";
             //   else
                    config = config + "* ";
            }

            configuration.WriteLine(config);
            configuration.Close();
        }

        private void получитьРасстановкуToolStripMenuItem_Click(object sender, EventArgs e)
        {
            StreamReader configuration;
            string configName = "";
            if (this.openFileDialog1.ShowDialog() == DialogResult.OK)
                configName = openFileDialog1.FileName;
            configuration = File.OpenText(configName);
            string vals = configuration.ReadLine();
            configuration.Close();            
            if (myGame.GetFix(vals))
                ShowButtons();
            else
            {
                myGame.Mix();
                ShowButtons();
                myGame.result = "Загружаемая расстановка некорректна" + "\r\n" +
                    "Загружена случайная расстановка!";
                AddToResult();
            }
             
        }
        /// <summary>
        /// Дополняет список ходов
        /// </summary>
        /// <param name="move"></param>
        public void ToList(string move)
        {
            listBoxMoves.Items.Add(move);
        }

        private void нормальноToolStripMenuItem_Click(object sender, EventArgs e)
        {
            sleepingTime = 1000;
        }

        private void быстроToolStripMenuItem_Click(object sender, EventArgs e)
        {
            sleepingTime = 100;
        }

        private void медленноToolStripMenuItem_Click(object sender, EventArgs e)
        {
            sleepingTime = 2000;
        }

        private void компьютерToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gamer = "computer";
        }

        private void человекToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gamer = "men";
        }
        /// <summary>
        /// Обработчик события Click по кнопке при игре человека
        /// </summary>
        /// <param name="sender"> нажатая кнопка</param>
        /// <param name="e">не используется</param>
        private void button_Click(object sender, EventArgs e)
        {
            if (gamer == "men")
            {
                Point p = ((Button)sender).Location;
                int dx = Math.Abs(p.X - ePoint.X);
                int dy = Math.Abs(p.Y - ePoint.Y);
                if (dx + dy == HW)  //кнопка - сосед пустой клетки
                {
                    //делаем ход
                    int i = FindCell(p);
                    Moving(i);
                }
            }
        }
        /// <summary>
        /// Увеличение счетчика в полосе прогресса 
        /// </summary>
        public void AddToProgressBar()
        {
            progressBarCount.PerformStep();
            textBoxCurrent.Text = "Правильно поставленных элементов: " +
                progressBarCount.Value.ToString();
        }
        /// <summary>
        /// Заполнение результата
        /// </summary>
        public void AddToResult()
        {
            textBoxResult.Text = myGame.result +
                "\r\n" +
                "Сделано ходов: " + myGame.moves.ToString();
        }
        /// <summary>
        /// Новая конфигурация
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void buttonMix_Click(object sender, EventArgs e)
        {
            myGame.Mix();
            ShowButtons();

        }

        private void Form_Игра_15_Click(object sender, EventArgs e)
        {
            // myGame.exit = true;
        }

        private void buttonStop_Click(object sender, EventArgs e)
        {
            myGame.exit = true;
            gamethread.Abort();
            AddToResult();
        }

       


       

        

       
        
    }
}
