﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ClassLibraryIntegral;

namespace WindowsFormsIntegral
{
    public partial class FormIntegral : Form
    {
        const int m = 8;
        string lab1 = "Последовательный \r\n Интервалов разбиения - ";
        string lab2 = "Параллельный \r\n Интервалов разбиения - ";
        Label[] labels = new Label[m];
        TextBox[] textboxesVal = new TextBox[m];
        TextBox[] textboxesTime = new TextBox[m];

        int x0 = 205, y0 = 420;
        int dx = 30, dy = 40;
        int w = 210, h = 40;

        double eps;
        int k;
        double a, b;
        double ampl, freq;

        public FormIntegral()
        {
            InitializeComponent();
            CreateComponents();
        }

        void CreateComponents()
        {
            
            for (int i = 0; i <m; i++)
            {
                labels[i] = new Label();
                this.Controls.Add(labels[i]);
                labels[i].Location =
                    new Point(x0, y0 + i  * dy);
                labels[i].Size = new Size(w, h);
                if (i % 2 == 0)
                    labels[i].Text = lab1;
                else
                    labels[i].Text = lab2;
            }
            for (int i = 0; i < m; i++)
            {
                textboxesVal[i] = new TextBox();
                this.Controls.Add(textboxesVal[i]);
                textboxesVal[i].Location =
                    new Point(x0 + w + 2*dx, y0 + i * dy);
                textboxesVal[i].Size = new Size(w, h);
                textboxesTime[i] = new TextBox();
                this.Controls.Add(textboxesTime[i]);
                textboxesTime[i].Location =
                    new Point(x0 + 2*w + 3*dx, y0 + i * dy);
                textboxesTime[i].Size = new Size(w, h);
               
            }
        }
         

        private void buttonEval_Click(object sender, EventArgs e)
        {
            //Чтение исходных данных
            eps = double.Parse(textBoxEps.Text);
            k = int.Parse(textBoxInterval_k.Text);
            a = double.Parse(textBoxLimit_a.Text);
            b = double.Parse(textBoxLimit_b.Text);
            ampl = double.Parse(textBoxAmplituda.Text);
            freq = double.Parse(textBoxFrequence_p.Text);

            //Дополнение меток информцией о числе интервалов
            int n = k;
            for (int i = 0; i < 8; i = i + 2)
            {
                labels[i].Text += n.ToString();
                labels[i+1].Text += n.ToString();
                n *= 4;
            }
            //Вычисление точного начения интеграла
            textBox_Math_Fun.Text = (TableIntegral(b) - TableIntegral(a)).ToString();

            //Последовательное интегрирование на всем интервале [a, b]
            Integral integral = new Integral(a, b, k, Integral_fun, eps);
            DateTime start, finish;
            double result = 0;
            start = DateTime.Now;
                result = integral.SequenceIntegral();
            finish = DateTime.Now;
            textBox_Seq_Fun.Text = result.ToString();
            textBox_Seq_Time.Text = ((finish - start).Ticks * 1e-7).ToString();

            //Параллельное и последовательное интегрирование с разбиением на интервалы
            n = k;
            for (int i = 0; i < 8; i = i + 2)
            {
                start = DateTime.Now;
                    result = integral.SequenceIntegralWithSegments(n);
                finish = DateTime.Now;
                textboxesVal[i].Text = result.ToString();
                textboxesTime[i].Text = ((finish - start).Ticks * 1e-7).ToString();

                start = DateTime.Now;
                    result = integral.ParallelIntegralWithSegments(n);
                finish = DateTime.Now;
                textboxesVal[i+1].Text = result.ToString();
                textboxesTime[i+1].Text = ((finish - start).Ticks * 1e-7).ToString();
                n *= 4;
            }


                

        
        }
        double TableIntegral(double x)
        {
            double result = ampl * (x - Math.Cos(x * freq) / freq);
            return result;
        }
        double Integral_fun(double x)
        {
            double result = ampl *(1 + Math.Sin(x * freq));
            return result;
        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            textBox_Math_Fun.Clear();
            textBox_Seq_Fun.Clear();
            textBox_Seq_Time.Clear();
            for (int i = 0; i < m; i++)
            {
                if (i % 2 == 0)
                    labels[i].Text = lab1;
                else
                    labels[i].Text = lab2;
                textboxesTime[i].Clear();
                textboxesVal[i].Clear();
            }
        }
    }
}
