﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ClassLibrarySorting;

namespace WindowsFormsSorting
{
    public partial class FormSorting : Form
    {
        public FormSorting()
        {
            InitializeComponent();
        }

        int N, max, p;

        const string YES = "Да";
        const string NO = "Нет";
        double[] source, mas;
        DateTime start, finish;
        double time = 0;
        private void buttonCreateAr_Click(object sender, EventArgs e)
        {
            N = int.Parse(textBoxN.Text);
            max = int.Parse(textBoxDiapason.Text);
           
            source = Sorting.Create_Random_Massiv(N, max);
            mas = new double[N];
            textBoxIsCreated.Text = YES;
        }

        private void buttonEvalBubbleSeq_Click(object sender, EventArgs e)
        {
            Array.Copy(source, mas, N);
           
            start = DateTime.Now;
                Sorting.BubbleSortClassic(mas);
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            if (Sorting.Is_Sorted(mas))
            {
                textBoxSortedBubbleSeq.Text = YES;
                textBoxTimeBubbleSeq.Text = time.ToString();
            }
            else
            {
                textBoxSortedBubbleSeq.Text = NO;
                textBoxTimeBubbleSeq.Text = time.ToString();
            }

        }

        private void buttonEvalBubbleParallel_Click(object sender, EventArgs e)
        {
            Array.Copy(source, mas, N);
            p = int.Parse(textBoxNGroup.Text);
            start = DateTime.Now;
            Sorting.BubbleParallel(mas, p);
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            if (Sorting.Is_Sorted(mas))
            {
                textBoxSortedBubbleParallel.Text = YES;
                textBoxTimeBubblePar.Text = time.ToString();
            }
            else
            {
                textBoxSortedBubbleParallel.Text = NO;
                textBoxTimeBubblePar.Text = time.ToString();
            }
        }

        private void buttonEvalQSortSeq_Click(object sender, EventArgs e)
        {
            Array.Copy(source, mas, N);

            start = DateTime.Now;
                Sorting.QuickSort(mas);
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            if (Sorting.Is_Sorted(mas))
            {
                textBoxSortedQSortSeq.Text = YES;
                textBoxTimeQSortSeq.Text = time.ToString();
            }
            else
            {
                textBoxSortedQSortSeq.Text = NO;
                textBoxTimeQSortSeq.Text = time.ToString();
            }

        }

        private void buttonQSortParallelGroup_Click(object sender, EventArgs e)
        {
            Array.Copy(source, mas, N);
            p = int.Parse(textBoxNGroup.Text);
            start = DateTime.Now;
                Sorting.QuickSortParallel(mas, p);
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            if (Sorting.Is_Sorted(mas))
            {
                textBoxSortedQSortParGroup.Text = YES;
                textBoxTimeQSortParGroup.Text = time.ToString();
            }
            else
            {
                textBoxSortedQSortParGroup.Text = NO;
                textBoxTimeQSortParGroup.Text = time.ToString();
            }
        }

        private void buttonQSortParallelRecursive_Click(object sender, EventArgs e)
        {
            Array.Copy(source, mas, N);
            
            start = DateTime.Now;
            Sorting.PQuickSort(mas);
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            if (Sorting.Is_Sorted(mas))
            {
                textBoxSortedQSortParRec.Text = YES;
                textBoxTimeQSortParRec.Text = time.ToString();
            }
            else
            {
                textBoxSortedQSortParRec.Text = NO;
                textBoxTimeQSortParRec.Text = time.ToString();
            }
        }

        private void buttonBatcherParallel_Click(object sender, EventArgs e)
        {
            Array.Copy(source, mas, N);
           
            start = DateTime.Now;
                Sorting.PBetcher(mas);
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            if (Sorting.Is_Sorted(mas))
            {
                textBoxSortedBatcherPar.Text = YES;
                TimeBatcherPar.Text = time.ToString();
            }
            else
            {
                textBoxSortedBatcherPar.Text = NO;
                TimeBatcherPar.Text = time.ToString();
            }
        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            textBoxSortedBatcherPar.Text = NO;
            textBoxSortedBubbleParallel.Text = NO;
            textBoxSortedBubbleSeq.Text = NO;
            textBoxSortedQSortParGroup.Text = NO;
            textBoxSortedQSortParRec.Text = NO;
            textBoxSortedQSortSeq.Text = NO;

            textBoxTimeBubblePar.Text = NO;
            textBoxTimeBubbleSeq.Text = NO;
            textBoxTimeQSortParGroup.Text = NO;
            textBoxTimeQSortParRec.Text = NO;
            textBoxTimeQSortSeq.Text = NO;
            TimeBatcherPar.Text = NO;

        }
    }
}
