﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using ClassLibrarySum;

namespace ConsoleFunction_Sum
{
    class Functiom_Sum
    {
        const int n = 10000;
        static int[] x;
        static long S;
        static double T;
        delegate void VV();

        static void Main(string[] args)
        {
            x = new int[n];
            Print(Sample1, "Последовательный алгоритм");
            Print(Sample1P, "Некорректное применение Parallel.For");
            Print(Sample2P, "Корректное частичное распараллеливание");
            Print(Sample3P, "Корректное полное распараллеливание");
            Print(Sample4P, "Распараллеливание с потоками");
            Print(Sample5P, "Распараллеливание с задачами");
        }
        static void Sample1()
        {
            S = 0;
            for (int i = 0; i < n; i++)
            {
                x[i] = Fx(i);
                S = S + Fs(i);
            }
        }
        static void Sample1P()
        {
            S = 0;
            Parallel.For(0, n, (i) =>
            {
                x[i] = Fx(i);
                S = S + Fs(i);
            });
        }
        static void Sample2P()
        {
            S = 0;
            for (int i = 0; i < n; i++)
                S = S + Fs(i);
            Parallel.For(0, n, (i) =>
            {
                x[i] = Fx(i);
            });
        }
        static void Sample3P()
        {
            int[] temp = new int[n];
            Parallel.For(0, n, (i) =>
            {
                x[i] = Fx(i);
                temp[i] = Fs(i);
            });
            S = 0;
            for (int i = 0; i < n; i++)
                S = S + temp[i];
        }
        static void Sample4P()
        {
            int[] temp = new int[n];
            Thread[] threads = new Thread[n];
            //создаем потоки
            for (int i = 0; i < n; i++)
            {
                threads[i] = new Thread((object p) =>
                {
                    int k = (int)p;
                    x[k] = Fx(k);
                    temp[k] = Fs(k);
                });
            }
            //запускаем потоки
            for (int i = 0; i < n; i++)
                threads[i].Start(i);
            //Ждем завершения
            for (int i = 0; i < n; i++)
                threads[i].Join();
            //Продолжаем работу
            S = 0;
            for (int i = 0; i < n; i++)
                S = S + temp[i];
        }
        /// <summary>
        /// Применяем задачи
        /// </summary>
        static void Sample5P()
        {
            int[] temp = new int[n];
            Task[] tasks = new Task[n];
            //создаем и запускаем задачи
            for (int i = 0; i < n; i++)
            {
                tasks[i] = new Task((object p) =>
                {
                    int k = (int)p;
                    x[k] = Fx(k);
                    temp[k] = Fs(k);
                }, i);
            }
            for (int i = 0; i < n; i++)
                tasks[i].Start();
            //Ждем завершения
            Task.WaitAll(tasks);
            //Продолжаем работу
            S = 0;
            for (int i = 0; i < n; i++)
                S = S + temp[i];
        }


        static int Fx(int i)
        {
            //имитация длинных вычислений
            const int m = 100000;
            int add = 1, t = 0;
            for (int k = 0; k < m; k++)
            {
                t += add;
                add *= -1;
            }
            return i * 10;
        }
        static int Fs(int i)
        {
            //имитация длинных вычислений
            const int m = 100000;
            int add = 1, t = 0;
            for (int k = 0; k < m; k++)
            {
                t += add;
                add *= -1;
            }
            return i;
        }
        static void Print(VV par, string mes)
        {
            DateTime start, finish;
            start = DateTime.Now;
            par();
            finish = DateTime.Now;
            T = (finish - start).Ticks * 1E-7;
            Console.WriteLine(mes);
            Console.WriteLine("S = {0}, T = {1}",
                S, T);
        }
    }
}
