﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ClassLibrarySum;

namespace WindowsFormsSum
{
    public partial class FormFunctionSum : Form
    {
        TextBox[,] textboxes = new TextBox[7, 3];
        Random rnd = new Random();
        
        double time = 0;        
        int n = 0;
        int p = 0;
        DateTime start, finish;
        public FormFunctionSum()
        {
            InitializeComponent();
            CreateComponents();
        }
        void CreateComponents()
        {
            int x0 = 280, y0 = 220;
            int dx = 30, dy = 30;
            int w = 100, h = 25;
            this.Height = 630;
            this.Width = 800;

            for (int i = 0; i < 7; i++)
                for (int j = 0; j < 3; j++)
                {
                    textboxes[i, j] = new TextBox();
                    this.Controls.Add(textboxes[i, j]);
                    textboxes[i, j].Location =
                        new Point(x0 + j * (dx + w), y0 + i * (dy + h));
                    textboxes[i, j].Size = new Size(w, h);
                }
            Label[] lab_Hearders = new Label[3];
            for (int i = 0; i < 3; i++)
            {
                lab_Hearders[i] = new Label();
                this.Controls.Add(lab_Hearders[i]);
                lab_Hearders[i].Location =
                    new Point(x0 + i * (w + dx), y0 - 30);
                lab_Hearders[i].Size = new Size(120, 30);
            }
            lab_Hearders[0].Text = "Fx[0] + Fx[n-1]";
            lab_Hearders[1].Text = "Sum_FS[i]";
            lab_Hearders[2].Text = "Время";

            Label[] labels = new Label[8];
            for (int i = 0; i < 8; i++)
            {
                labels[i] = new Label();
                this.Controls.Add(labels[i]);
                labels[i].Location =
                    new Point(50, y0 + (i - 1) * (dy + h));
                labels[i].Size = new Size(200, 30);
            }
            labels[0].Text = "Алгоритмы";
            labels[0].Location = new Point(70, y0 - 30);
            labels[1].Text = "Последовательный";
            labels[2].Text = "Некорректный Parallel.For";
            labels[3].Text = "Частично параллельный";
            labels[4].Text = "Полное распараллеливание";
            labels[5].Text = "Шаговый параллельный";
            labels[6].Text = "Параллельный с потоками";
            labels[7].Text = "Параллельный с задачами";

        }

        private void buttonCreateTable_Click(object sender, EventArgs e)
        {
            n = int.Parse(textBoxN.Text);
            p = int.Parse(textBoxP.Text);
            double S, F;
            Sum_Function sumF = new Sum_Function(n, p);
            start = DateTime.Now;
            sumF.Seq_SumF();
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            textboxes[0, 2].Text = time.ToString();
            sumF.Results(out S, out F);
            textboxes[0, 0].Text = F.ToString();
            textboxes[0, 1].Text = S.ToString();

            start = DateTime.Now;
            sumF.UncorrectParallel();
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            textboxes[1, 2].Text = time.ToString();
            sumF.Results(out S, out F);
            textboxes[1, 0].Text = F.ToString();
            textboxes[1, 1].Text = S.ToString();

            start = DateTime.Now;
            sumF.Partition_Parallel();
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            textboxes[2, 2].Text = time.ToString();
            sumF.Results(out S, out F);
            textboxes[2, 0].Text = F.ToString();
            textboxes[2, 1].Text = S.ToString();

            start = DateTime.Now;
            sumF.Full_Parallel();
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            textboxes[3, 2].Text = time.ToString();
            sumF.Results(out S, out F);
            textboxes[3, 0].Text = F.ToString();
            textboxes[3, 1].Text = S.ToString();

            start = DateTime.Now;
            sumF.Step_SumF();
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            textboxes[4, 2].Text = time.ToString();
            sumF.Results(out S, out F);
            textboxes[4, 0].Text = F.ToString();
            textboxes[4, 1].Text = S.ToString();

            start = DateTime.Now;
            sumF.Parallel_with_Threads();
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            textboxes[5, 2].Text = time.ToString();
            sumF.Results(out S, out F);
            textboxes[5, 0].Text = F.ToString();
            textboxes[5, 1].Text = S.ToString();

            start = DateTime.Now;
            sumF.Parallel_with_Tasks();
            finish = DateTime.Now;
            time = (finish - start).Ticks * 1e-7;
            textboxes[6, 2].Text = time.ToString();
            sumF.Results(out S, out F);
            textboxes[6, 0].Text = F.ToString();
            textboxes[6, 1].Text = S.ToString();

        }

        private void buttonClearTable_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < 7; i++)
                for (int j = 0; j < 3; j++)
                    textboxes[i, j].Clear();
        }
    }
}
