﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ClassLibrarySum;

namespace WindowsFormsSum
{
    public partial class FormMassiv_Sum : Form
    {
        TextBox[,] textboxes = new TextBox[6, 4];
        Random rnd = new Random();
        double Sum = 0;
        double time = 0;
        int p = 0;
        public FormMassiv_Sum()
        {
            InitializeComponent();
            CreateComponents();
        }
        void CreateComponents()
        {
            int x0 = 200, y0 = 220;
            int dx = 30, dy = 30;
            int w = 100, h = 25;
            this.Height = 600;
            this.Width = 800;

            for (int i = 0; i < 6; i++)
                for (int j = 0; j < 4; j++)
                {
                    textboxes[i, j] = new TextBox();
                    this.Controls.Add(textboxes[i, j]);
                    textboxes[i, j].Location =
                        new Point(x0 + j * (dx + w), y0 + i * (dy + h));
                    textboxes[i, j].Size = new Size(w, h);
                }
            Label[] labels = new Label[6];
            for (int i = 0; i < 6; i++)
            {
                labels[i] = new Label();
                this.Controls.Add(labels[i]);
                labels[i].Location =
                    new Point(50, y0 + i * (dy + h));
                labels[i].Size = new Size(180, 30);
            }
            labels[0].Text = "Алгоритмы";
            labels[0].Location = new Point(70, y0 + 30);
            labels[1].Text = "Последовательный";
            labels[2].Text = "Пирамидальный";
            labels[3].Text = "Сегментный";
            labels[4].Text = "Шаговый";
            labels[5].Text = "Шаговый с потоками";

        }


        private void buttonCreateTable_Click(object sender, EventArgs e)
        {
            int init_Size = int.Parse(textBoxSize_Init.Text);
            int scale = int.Parse(textBoxScale.Text);
            p = int.Parse(textBoxP.Text);
            int size = init_Size;
            for (int i = 0; i < 4; i++)
            {
                size = size * scale;
                textboxes[0, i].Text = size.ToString();
                Massiv mas = new Massiv(size, p, 2000);
                mas.CreateRandomMassiv();

                Sum = mas.Sum_Seq(out time);
                textboxes[1, i].Text = time.ToString();
                Sum = mas.Sum_Piramid(out time);
                textboxes[2, i].Text = time.ToString();
                Sum = mas.Sum_Seg(out time);
                textboxes[3, i].Text = time.ToString();
                Sum = mas.Sum_Step(out time);
                textboxes[4, i].Text = time.ToString();
                Sum = mas.Sum_Thread(out time);
                textboxes[5, i].Text = time.ToString();

            }
        }

        private void buttonClearTable_Click(object sender, EventArgs e)
        {
            for (int i = 0; i < 6; i++)
                for (int j = 0; j < 4; j++)
                    textboxes[i, j].Clear();
        }
    }
}
