﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace ClassLibraryFilosofDinner
{
    public class ThinkWhenEat
    {
        int count;
        int repeat;
        SemaphoreSlim[] forks;
        Thread[] threads;
        string[] states;
        const int think_time = 100;
        const int wait_time = 50;
        const int eat_time = 20;
        public string[] States
        {
            get { return states; }
        }
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="n">число философов</param>
        public ThinkWhenEat(int n, int rep)
        {
            count = n;
            repeat = rep;
            forks = new SemaphoreSlim[count];
            states = new string[count];
            threads = new Thread[count];
            for (int i = 0; i < count; i++)
            {
                forks[i] = new SemaphoreSlim(1, 1);
                states[i] = "";
            }
        }
        /// <summary>
        /// Каждому философу свой поток для обеда
        /// </summary>
        public void Dinner()
        {
            for (int j = 0; j < count; j++)
            {
                int index = j;
                threads[index] = new Thread(DinnerForFhilosophers);
                threads[index].Start(index);
            }
        }
        
        /// <summary>
        /// Обед философа
        /// </summary>
        /// <param name="index"></param>
        void DinnerForFhilosophers(object index)
        {
            int num = (int)index;
            SemaphoreSlim left_fork = forks[num];
            SemaphoreSlim right_fork = forks[(num + 1) % count];
            if (num  == count -1)
            { //change forks
                SemaphoreSlim temp;
                temp = left_fork;
                left_fork = right_fork;
                right_fork = temp;
            }
            for (int i = 0; i < repeat; i++)
            {
                // think
                states[num] += "thinks => ";
                Thread.Sleep(think_time);
                //wait
                left_fork.Wait();
                 states[num] += "waits =>";
                Thread.Sleep(wait_time);
                //eat
                right_fork.Wait();
                states[num] += "eats => "; 
                Thread.Sleep(eat_time);
                //Освобождает вилки
                left_fork.Release();
                right_fork.Release();
            }
        }


    }

}
