﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace ClassLibraryReadersWriters
{
    /// <summary>
    /// Моделирование работы над программным проектом
    /// </summary>
    public class Model
    {
        int ndev, ntes, nprog, n;
        string programs;
        
        Project project;
        const int rep = 5;
        
        Random rnd = new Random();
        Thread[] threads;
        public Project MyProject
        {
            get { return project; }
        }
        
        /// <summary>
        /// Конструктор
        /// </summary>
        /// <param name="nd">число разработчиков</param>
        /// <param name="nt">тестеров</param>
        /// <param name="np">программистов - пользователей проекта</param>
        public Model(int nd, int nt, int np)
        {
            n = nd + nt + np;
            this.ndev = nd;
            this.ntes = nt;
            this.nprog = np;
            programs = "";
            project = new Project();
            threads = new Thread[n * rep];
        }
        /// <summary>
        /// Реализация сценария работы с проектом
        /// </summary>
        public void ModelWorkWithProject()
        {
            int num = 0;
            int version = 1;
            int patch = 1;
            for (int i = 0; i < n * rep; i++)
            {
                //Генерация случайного события
                num = rnd.Next(n);
                if (num < ndev)
                {
                    //Создается поток разработчиков
                    threads[i] = new Thread(() =>
                        {
                            project.WriteNewProgram(String.Format(
                            "version {0}  from Devoleper {1} ", version, num));
                        });
                    threads[i].Start();
                    version++;
                }
                else
                    if (num < ndev + ntes)
                    {
                        //Создается поток тестеров
                        threads[i] = new Thread(() =>
                        {
                            project.EditNewProgram(String.Format(
                                    " patch {0}  from Tester {1}", patch, num - ndev));
                        });
                        threads[i].Start();
                        patch++;
                    }
                    else
                    {
                        //Создается поток программистов
                        threads[i] = new Thread(() =>
                        {
                            project.ReadingProgram(String.Format(
                                " used by User {0}", num - ndev - ntes));
                        });
                        threads[i].Start();
                    }
                Thread.Sleep(5);
            }
            for (int i = 0; i < n * rep; i++)
            {
                threads[i].Join();
            }
        }
    }


}
