﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace ClassLibraryReadersWriters
{
    /// <summary>
    /// Программный проект, над которым работают
    /// (developers), (testers), (programmers)
    /// (писатели), (редакторы), (читатели) 
    /// </summary>
    public class Project
    {
        string program = "";
        const string nl = "\r\n";
        int dq = 0, tq =0, pq = 0;   //максимальная длина очередей
        public string Program
        {
            get { return program; }
        }
        public int DQ
        {
            get { return dq; }
        }
        public int TQ
        {
            get { return tq; }
        }
        public int PQ
        {
            get { return pq; }
        }
        ReaderWriterLockSlim wer = new ReaderWriterLockSlim();
        /// <summary>
        ///For Writers 
        /// </summary>
        /// <param name="prog">новая версия программы</param>
        public void WriteNewProgram(string prog)
        {
            if (wer.WaitingWriteCount > dq)
                dq = wer.WaitingWriteCount;            
            wer.EnterWriteLock();
            try
            {
                program += prog + nl;
                Thread.Sleep(50);
            }
            finally
            {
                wer.ExitWriteLock();
            }
        }
        /// <summary>
        ///For Editors 
        /// </summary>
        /// <param name="prog">новое изменение программы</param>
        public void EditNewProgram(string patch)
        {

            if (wer.WaitingUpgradeCount > tq)
                tq = wer.WaitingUpgradeCount;
            wer.EnterUpgradeableReadLock();
            try
            {
                if (program != "")
                    program += patch + nl;
                Thread.Sleep(10);
            }
            finally
            {
                wer.ExitUpgradeableReadLock();
            }
        }
        /// <summary>
        ///For Readers 
        /// </summary>
        /// <param name="prog">чтение программы</param>
        public void ReadingProgram(string user)
        {
            if (wer.WaitingReadCount > pq)
                pq = wer.WaitingReadCount;    
            wer.EnterReadLock();
            try
            {
                program += user + nl;
                Thread.Sleep(10);
            }
            finally
            {
                wer.ExitReadLock();
            }
        }
    }



}
