﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace ClassLibraryTasksAndInstruments
{
  public  class Garnitur
    {
        Accessory ring;
        Accessory earrings;
        public Garnitur(int price_R, int price_E, string dec_R, string dec_E)
        {
            ring = new Accessory("ring", price_R, dec_R);
            earrings = new Accessory("earrings", price_E, dec_E);
        }
        object lock_ring = new object();
        object lock_earrings = new object();

        /// <summary>
        /// Покупка гарнитура
        /// начинается с покупки кольца
        /// </summary>
        /// <param name="Sum">сумма, отводимая для покупки</param>
        /// <param name="ring_success">true при успехе покупки кольца</param>
        /// <param name="earrings_success">true при успехе покупки серьг</param>
        /// <param name="compare_ring_earrings">описание гарнитура </param>
        public void Buy_RingAndEarRings(int Sum, out bool ring_success,
            out bool earrings_success, ref string compare_ring_earrings)
        {
            lock (lock_ring)
            {
                //Покупка кольца
                if (!ring.Sold && Sum >= ring.Price)
                {
                    ring.Sold = true;
                    ring_success = true;
                    Sum -= ring.Price;
                }
                else ring_success = false;
                //Пьем кофе
                Thread.Sleep(10);
                lock (lock_earrings)
                {
                    //сравнение кольца и сережек
                    compare_ring_earrings += ring.Declaration + " - " +
                        earrings.Declaration;
                    //Покупка сережек
                    if (!earrings.Sold && Sum >= earrings.Price)
                    {
                        earrings.Sold = true;
                        earrings_success = true;
                    }
                    else earrings_success = false;
                    //Пьем кофе
                    Thread.Sleep(10);
                }
            }
        }
        /// <summary>
        /// Покупка гарнитура
        /// начинается с покупки сережек
        /// </summary>
        /// <param name="Sum">сумма, отводимая для покупки</param>
        /// <param name="ring_success">true при успехе покупки кольца</param>
        /// <param name="earrings_success">true при успехе покупки серьг</param>
        /// <param name="compare_ring_earrings">описание гарнитура </param>
        public void Buy_EarRingsAndRing(int Sum, out bool ring_success,
            out bool earrings_success, ref string compare_ring_earrings)
        {
           
                //покупка сережек
                lock (lock_earrings)
                {
                    //сравнение кольца и сережек
                    compare_ring_earrings += ring.Declaration + " - " +
                        earrings.Declaration;
                    //Покупка сережек
                    if (!earrings.Sold && Sum >= earrings.Price)
                    {
                        earrings.Sold = true;
                        earrings_success = true;
                    }
                    else earrings_success = false;
                    //Пьем кофе
                    Thread.Sleep(10);
                
                lock (lock_ring)
                {
                //Покупка кольца
                if (!ring.Sold && Sum >= ring.Price)
                {
                    ring.Sold = true;
                    ring_success = true;
                    Sum -= ring.Price;
                }
                else ring_success = false;
                //Пьем кофе
                Thread.Sleep(10);
                }
               
            }
        }

    }
}
