﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ClassLibraryTasksAndInstruments;
using System.Threading;

namespace WindowsFormsTasksAndInstruments
{
    public partial class FormAccount : Form
    {
        public FormAccount()
        {
            InitializeComponent();
        }
        int n = 20000, m = 20000;
        double husband_sum = 0;
        double wife_sum = 0;
        double daughter_sum = 0;
        Account account;
        double Init;
        private void buttonUnsafe_Click(object sender, EventArgs e)
        {
            Init = 1000;
            account = new Account(Init);
            Go();
        }
        /// <summary>
        /// В трех разных потоках
        /// моделируется параллельная работа со счетом
        /// трех членов одной семьи - мужа, его жены и дочери        
        /// </summary>
        void Go()
        {
            husband_sum = wife_sum = daughter_sum = 0;
            //Создание потоков для трех клиентов 
            Thread h = new Thread(Husband);
            Thread w = new Thread(Wife);
            Thread d = new Thread(Daughter);
            //запуск их методов на выполнение
            h.Start();
            d.Start();
            w.Start();
            //Пора подвести итоги работы
            d.Join();
            h.Join();
            w.Join();
            textBoxHusband.Text = husband_sum.ToString();
            textBoxWife.Text = wife_sum.ToString();
            textBoxDaughter.Text = daughter_sum.ToString();
            textBoxBalance.Text = account.Sum.ToString();
            
            if (husband_sum != daughter_sum + wife_sum + account.Sum)
                textBoxIsCorrect.Text = "Нет!!! Опасные операции над счетом!";
            else
                textBoxIsCorrect.Text = "Да!  Все операции прошли корректно!";

        }
        void Husband()
        {
            husband_sum = Init;
            for (int i = 0; i < n; i++)
            {
                account.Add(300);
                if (!account.Error)
                    husband_sum += 300;
            }
        }
        void Wife()
        {
            for (int i = 0; i < m; i++)
            {
                account.Sub(400);
                if (!account.Error)
                    wife_sum += 400;
            }
        }
        void Daughter()
        {
            if (account == null) Thread.Sleep(0);
            for (int i = 0; i < m; i++)
            {
                account.Sub(500);
                if (!account.Error)
                    daughter_sum += 500;
            }
        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            textBoxBalance.Clear();
            textBoxDaughter.Clear();
            textBoxHusband.Clear();
            textBoxIsCorrect.Clear();
            textBoxWife.Clear();
        }

        private void buttonSafe_Click(object sender, EventArgs e)
        {
            Init = 1000;
            account = new SafeAccount(Init);
            Go();

        }


    }
}
